com.sap.conn.jco

## Interface JCoCustomDestination

- All Superinterfaces:
    JCoDestination

      public interface JCoCustomDestination
      extends JCoDestination

  A JCoCustomDestination is a customizable destination which allows to set specific user logon data and SNC configuration parameters. It is useful, if a JCoDestination, which is obtained from the JCoDestinationManager, does not contain the required logon credentials or if a business application would like to use remote function call specific logon parameters that shall be set programmatically at application runtime, for example if these parameters are short-lived login credentials obtained from an interactive user dialog screen.
  JCoCustomDestination instances do not share connection pools and stateful call contexts with basic configured JCoDestination instances. But JCoCustomDestination instances share connection pools and stateful call contexts with other JCoCustomDestination instances as long as they have been created from the same basic configured JCoDestination and also use the same logon parameters.
  Furthermore a JCoCustomDestination will use the JCoRepository instance of the basic configured JCoDestination object which it originates from. Hence, JCoCustomDestinations and therein specified logon parameters are not used by a standard dynamic JCoRepository for doing meta data queries.
  A JCoCustomDestination instance cannot be modified anymore after it has been used for executing an application RFC request. But it can be used for creating a new modifiable JCoCustomDestination instance again.
  See Also:
    `JCoDestination.createCustomDestination()`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `JCoCustomDestination.SncConfigurationData` SncConfigurationData allows to change the SNC configuration for a JCoCustomDestination.
    `static interface` | `JCoCustomDestination.UserData` UserData allows to change the user logon data for a JCoCustomDestination.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `JCoDestination` | `getOriginalDestination()` Returns the original destination, also known as the parent destination of this custom destination.
    `JCoCustomDestination.SncConfigurationData` | `getSNCConfiguration()` Returns the container for the properties of the SNC configuration.
    `JCoCustomDestination.UserData` | `getUserLogonData()` Returns the container for the properties of the user logon data.
    `void` | `setCodepage(String codepage)` The RFC communication negotiates the code page to use with its communication partner.
    `void` | `setRepositoryDestination(JCoDestination destination)` Sets the destination, whose repository will be used for meta data queries for this destination.
    `void` | `setTrace(boolean trace)` Allows to switch the RFC trace on and off.
    `void` | `setUseSapGui(boolean useSapGui)` Allows to switch the association of an SAP GUI with the used JCo connection on and off.

    - ### Methods inherited from interface com.sap.conn.jco.JCoDestination

      `changePassword, confirmFunctionUnit, confirmTID, createCustomDestination, createTID, getAliasUser, getApplicationServerHost, getAttributes, getClient, getDestinationID, getDestinationName, getExpirationCheckPeriod, getExpirationTime, getExternalIDData, getExternalIDType, getFunctionUnitState, getGatewayHost, getGatewayService, getLanguage, getLogonCheck, getLogonGroup, getMaxGetClientTime, getMessageServerHost, getMessageServerService, getMonitor, getP12FilePath, getPeakLimit, getPoolCapacity, getProperties, getProxyHost, getProxyPort, getProxyUser, getR3Name, getRepository, getRepositoryDestinationMonitor, getRepositoryUser, getSAPRouterString, getSncLibrary, getSncMode, getSncMyName, getSncPartnerName, getSncQOP, getSncSSO, getSystemNumber, getThroughput, getTPHost, getTPName, getType, getUser, getWebSocketHost, getWebSocketPort, isPooledConnectionChecked, isValid, ping, removeThroughput, setThroughput, trustAllForTLS, usesTLS`

- - ### Method Detail

    - #### setRepositoryDestination

          void setRepositoryDestination(JCoDestination destination)
                                        throws JCoException

      Sets the destination, whose repository will be used for meta data queries for this destination. In case a JCoCustomDestination is passed, the destination which it originates from will provide its repository.
      Parameters:
        `destination` - the destination to ask for the repository
      Throws:
        `JCoException` - if an exception occurs during the initialization of connections to the given destination
      See Also:
        `JCoDestination.getRepository()`

    - #### getOriginalDestination

          JCoDestination getOriginalDestination()

      Returns the original destination, also known as the parent destination of this custom destination.
      Returns:
        the parent destination of this custom destination
      Since:
        JCo 3.1.0

    - #### getSNCConfiguration

          JCoCustomDestination.SncConfigurationData getSNCConfiguration()

      Returns the container for the properties of the SNC configuration.
      Returns:
        SncConfigurationData

    - #### getUserLogonData

          JCoCustomDestination.UserData getUserLogonData()

      Returns the container for the properties of the user logon data.
      Returns:
        UserData

    - #### setTrace

          void setTrace(boolean trace)

      Allows to switch the RFC trace on and off.
      Parameters:
        `trace` - if set to true, the RFC trace will be switched on, otherwise it will be switched off
      Since:
        JCo 3.0.2

    - #### setCodepage

          void setCodepage(String codepage)

      The RFC communication negotiates the code page to use with its communication partner. Nevertheless, it can be necessary, to use a different initial one, if the logon language is not fitting to it. In case the logon data is changed, it might be necessary to adjust the code page as well.
      Parameters:
        `codepage` - the code page to use for the initial request
      Since:
        JCo 3.0.2

    - #### setUseSapGui

          void setUseSapGui(boolean useSapGui)

      Allows to switch the association of an SAP GUI with the used JCo connection on and off.
      Parameters:
        `useSapGui` - if set to true, a GUI will be attached to the connection, otherwise it won't
      Since:
        JCo 3.0.5

Copyright © 2020 SAP. All Rights Reserved.